Index: /LMDZ6/branches/LMDZ_ECRad/libf/phylmdiso/surf_land_mod.F90
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/phylmdiso/surf_land_mod.F90	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/phylmdiso/surf_land_mod.F90	(revision 4727)
@@ -11,5 +11,5 @@
        rlon, rlat, yrmu0, &
        debut, lafin, zlev, ccanopy, swnet, lwnet, albedo, &
-       tsurf, p1lay, cdragh, cdragm, precip_rain, precip_snow, temp_air, spechum, &
+       tsurf, p1lay, cdragh, cdragm, precip_rain, precip_snow, precip_bs, temp_air, spechum, &
        AcoefH, AcoefQ, BcoefH, BcoefQ, &
        AcoefU, AcoefV, BcoefU, BcoefV, & 
@@ -17,5 +17,5 @@
        lwdown_m, q2m, t2m, &
        snow, qsol, agesno, tsoil, &
-       z0m, z0h, SFRWL, alb_dir_new, alb_dif_new, evap, fluxsens, fluxlat, &   
+       z0m, z0h, SFRWL, alb_dir_new, alb_dif_new, evap, fluxsens, fluxlat, fluxbs, &   
        qsurf, tsurf_new, dflux_s, dflux_l, &
        flux_u1, flux_v1 , & 
@@ -94,5 +94,5 @@
     REAL, DIMENSION(klon), INTENT(IN)       :: p1lay
     REAL, DIMENSION(klon), INTENT(IN)       :: cdragh, cdragm
-    REAL, DIMENSION(klon), INTENT(IN)       :: precip_rain, precip_snow
+    REAL, DIMENSION(klon), INTENT(IN)       :: precip_rain, precip_snow, precip_bs
     REAL, DIMENSION(klon), INTENT(IN)       :: temp_air, spechum
     REAL, DIMENSION(klon), INTENT(IN)       :: AcoefH, AcoefQ, BcoefH, BcoefQ
@@ -129,5 +129,5 @@
 !albedo SB <<<
     REAL, DIMENSION(klon), INTENT(OUT)       :: evap
-    REAL, DIMENSION(klon), INTENT(OUT)       :: fluxsens, fluxlat
+    REAL, DIMENSION(klon), INTENT(OUT)       :: fluxsens, fluxlat, fluxbs
     REAL, DIMENSION(klon), INTENT(OUT)       :: qsurf
     REAL, DIMENSION(klon), INTENT(OUT)       :: tsurf_new
@@ -152,4 +152,5 @@
     REAL, DIMENSION(klon) :: tsol_rad, emis_new ! output from interfsol not used
     REAL, DIMENSION(klon) :: u0, v0     ! surface speed
+    REAL, DIMENSION(klon) :: precip_totsnow     ! total solid precip
     INTEGER               :: i
 
@@ -166,4 +167,13 @@
 #endif  
 
+!****************************************************************************************
+!Total solid precip
+
+IF (ok_bs) THEN
+precip_totsnow(:)=precip_snow(:)+precip_bs(:)
+ELSE
+precip_totsnow(:)=precip_snow(:)
+ENDIF
+!****************************************************************************************
 #ifdef ISO
 #ifdef ISOVERIF
@@ -228,7 +238,7 @@
             zlev,  u1, v1, gustiness, temp_air, spechum, epot_air, ccanopy, & 
             cdragh, AcoefH, AcoefQ, BcoefH, BcoefQ, &
-            precip_rain, precip_snow, lwdown_m, swnet, swdown, &
+            precip_rain, precip_totsnow, lwdown_m, swnet, swdown, &
             pref_tmp, q2m, t2m, &
-            evap, fluxsens, fluxlat, &              
+            evap, fluxsens, fluxlat,  &              
             tsol_rad, tsurf_new, alb1_new, alb2_new, &
             emis_new, z0m, z0h, qsurf, &
@@ -277,5 +287,5 @@
 #endif
        CALL surf_land_bucket(itime, jour, knon, knindex, debut, dtime,&
-            tsurf, p1lay, cdragh, precip_rain, precip_snow, temp_air, &
+            tsurf, p1lay, cdragh, precip_rain, precip_totsnow, temp_air, &
             spechum, AcoefH, AcoefQ, BcoefH, BcoefQ, pref, &
             u1, v1, gustiness, rugoro, swnet, lwnet, &
@@ -293,4 +303,6 @@
     ENDIF ! ok_veget
 
+        ! blowing snow not treated yet over land
+        fluxbs(:)=0.
 !****************************************************************************************
 ! Calculation for all land models
Index: /LMDZ6/branches/LMDZ_ECRad/libf/phylmdiso/surf_landice_mod.F90
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/phylmdiso/surf_landice_mod.F90	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/phylmdiso/surf_landice_mod.F90	(revision 4727)
@@ -12,10 +12,11 @@
        rmu0, lwdownm, albedo, pphi1, &
        swnet, lwnet, tsurf, p1lay, &
-       cdragh, cdragm, precip_rain, precip_snow, temp_air, spechum, &
+       cdragh, cdragm, precip_rain, precip_snow, precip_bs, temp_air, spechum, &
        AcoefH, AcoefQ, BcoefH, BcoefQ, &
        AcoefU, AcoefV, BcoefU, BcoefV, &
+       AcoefQBS, BcoefQBS, &
        ps, u1, v1, gustiness, rugoro, pctsrf, &
-       snow, qsurf, qsol, agesno, &
-       tsoil, z0m, z0h, SFRWL, alb_dir, alb_dif, evap, fluxsens, fluxlat, &
+       snow, qsurf, qsol, qbs1, agesno, &
+       tsoil, z0m, z0h, SFRWL, alb_dir, alb_dif, evap, fluxsens, fluxlat, fluxbs, &
        tsurf_new, dflux_s, dflux_l, &
        alt, slope, cloudf, &
@@ -34,5 +35,6 @@
     USE cpl_mod,          ONLY : cpl_send_landice_fields
     USE calcul_fluxs_mod
-    USE phys_output_var_mod
+    USE phys_local_var_mod, ONLY : zxrhoslic, zxustartlic
+    USE phys_output_var_mod, ONLY : snow_o,zfra_o
 #ifdef ISO   
     USE fonte_neige_mod,  ONLY : xtrun_off_lic
@@ -48,5 +50,5 @@
 !FC
     USE ioipsl_getin_p_mod, ONLY : getin_p
-
+    USE lmdz_blowing_snow_ini, ONLY : zeta_bs, pbst_bs, prt_bs, iflag_saltation_bs
 
 #ifdef CPP_INLANDSIS
@@ -72,11 +74,12 @@
     REAL, DIMENSION(klon), INTENT(IN)             :: p1lay
     REAL, DIMENSION(klon), INTENT(IN)             :: cdragh, cdragm
-    REAL, DIMENSION(klon), INTENT(IN)             :: precip_rain, precip_snow
+    REAL, DIMENSION(klon), INTENT(IN)             :: precip_rain, precip_snow, precip_bs
     REAL, DIMENSION(klon), INTENT(IN)             :: temp_air, spechum
     REAL, DIMENSION(klon), INTENT(IN)             :: AcoefH, AcoefQ
     REAL, DIMENSION(klon), INTENT(IN)             :: BcoefH, BcoefQ
     REAL, DIMENSION(klon), INTENT(IN)             :: AcoefU, AcoefV, BcoefU, BcoefV
+    REAL, DIMENSION(klon), INTENT(IN)             :: AcoefQBS, BcoefQBS
     REAL, DIMENSION(klon), INTENT(IN)             :: ps
-    REAL, DIMENSION(klon), INTENT(IN)             :: u1, v1, gustiness
+    REAL, DIMENSION(klon), INTENT(IN)             :: u1, v1, gustiness, qbs1
     REAL, DIMENSION(klon), INTENT(IN)             :: rugoro
     REAL, DIMENSION(klon,nbsrf), INTENT(IN)       :: pctsrf
@@ -118,4 +121,5 @@
 !albedo SB <<<
     REAL, DIMENSION(klon), INTENT(OUT)            :: evap, fluxsens, fluxlat
+    REAL, DIMENSION(klon), INTENT(OUT)            :: fluxbs
     REAL, DIMENSION(klon), INTENT(OUT)            :: tsurf_new
     REAL, DIMENSION(klon), INTENT(OUT)            :: dflux_s, dflux_l      
@@ -179,5 +183,12 @@
 
     REAL,DIMENSION(klon) :: alb1,alb2
+    REAL,DIMENSION(klon) :: precip_totsnow, evap_totsnow
     REAL, DIMENSION (klon,6) :: alb6
+    REAL                   :: rho0, rhoice, ustart0,esalt, rhod
+    REAL                   :: lambdasalt,fluxsalt, csalt, nunu, aa, bb, cc
+    REAL                   :: tau_dens, tau_dens0, tau_densmin, rhomax, rhohard
+    REAL, DIMENSION(klon)  :: ws1, rhos, ustart, qsalt, hsalt, snowini
+    REAL                   :: maxerosion ! in kg/s
+
 ! End definition
 !****************************************************************************************
@@ -214,15 +225,13 @@
            PRINT*, 'alb_nir_sno_lic',alb_nir_sno_lic
   
-!  z0m=1.e-3
-!  z0h = z0m
   firstcall=.false.
   ENDIF
 !******************************************************************************************
-!
+
 ! Initialize output variables
     alb3(:) = 999999.
     alb2(:) = 999999.
     alb1(:) = 999999.
-    
+    fluxbs(:)=0.  
     runoff(:) = 0.
 !****************************************************************************************
@@ -232,4 +241,6 @@
     radsol(:) = 0.0
     radsol(1:knon) = swnet(1:knon) + lwnet(1:knon)
+
+!****************************************************************************************
 
 !****************************************************************************************
@@ -327,5 +338,4 @@
 
 
-
     ELSE 
 
@@ -342,6 +352,5 @@
     IF (soil_model) THEN 
        CALL soil(dtime, is_lic, knon, snow, tsurf, qsol, &
-    & longitude(knindex(1:knon)), latitude(knindex(1:knon)), tsoil, soilcap, soilflux)
-
+        & longitude(knindex(1:knon)), latitude(knindex(1:knon)), tsoil, soilcap, soilflux)
        cal(1:knon) = RCPD / soilcap(1:knon)
        radsol(1:knon)  = radsol(1:knon) + soilflux(1:knon)
@@ -406,11 +415,142 @@
          flux_u1, flux_v1)
 
-!****************************************************************************************
-! Calculate snow height, age, run-off,..
+
+!****************************************************************************************
+! Calculate albedo
+!
+!****************************************************************************************
+ 
+    CALL albsno(klon,knon,dtime,agesno(:),alb_neig(:), precip_snow(:))  
+
+
+! EV: following lines are obsolete since we set alb1 and alb2 to constant values
+! I therefore comment them
+!    alb1(1:knon) = alb_neig(1:knon)*zfra(1:knon) + &
+!         0.6 * (1.0-zfra(1:knon))
+!
+!IM: plusieurs choix/tests sur l'albedo des "glaciers continentaux"
+!       alb1(1 : knon)  = 0.6 !IM cf FH/GK 
+!       alb1(1 : knon)  = 0.82
+!       alb1(1 : knon)  = 0.77 !211003 Ksta0.77
+!       alb1(1 : knon)  = 0.8 !KstaTER0.8 & LMD_ARMIP5
+!IM: KstaTER0.77 & LMD_ARMIP6    
+
+! Attantion: alb1 and alb2 are not the same!
+    alb1(1:knon)  = alb_vis_sno_lic
+    alb2(1:knon)  = alb_nir_sno_lic
+
+
+!****************************************************************************************
+! Rugosity
+!
+!****************************************************************************************
+    z0m = z0m_landice
+    z0h = z0h_landice
+    !z0m = SQRT(z0m**2+rugoro**2)
+
+
+
+  ! Simple blowing snow param
+  if (ok_bs) then
+       ustart0 = 0.211
+       rhoice = 920.0
+       rho0 = 300.0
+       rhomax=450.0
+       rhohard=450.0
+       tau_dens0=86400.0*10.  ! 10 days by default, in s
+       tau_densmin=21600.0    ! 1/4 days according to in situ obs by C. Amory during blowing snow +
+                              ! Marshall et al. 1999 (snow densification during rain)
+
+       ! computation of threshold friction velocity
+       ! which depends on surface snow density
+       do j = 1, knon
+           ! estimation of snow density
+           ! snow density increases with snow age and
+           ! increases even faster in case of sedimentation of blowing snow or rain
+           tau_dens=max(tau_densmin, tau_dens0*exp(-abs(precip_bs(j))/pbst_bs &
+                   -abs(precip_rain(j))/prt_bs) *exp(-max(tsurf(j)-272.0,0.)))
+           rhos(j)=rho0+(rhohard-rho0)*(1.-exp(-agesno(j)*86400.0/tau_dens))
+           ! blowing snow flux formula used in MAR
+           ws1(j)=(u1(j)**2+v1(j)**2)**0.5
+           ustar(j)=(cdragm(j)*(u1(j)**2+v1(j)**2))**0.5
+           ustart(j)=ustart0*exp(max(rhoice/rho0-rhoice/rhos(j),0.))*exp(max(0.,rhos(j)-rhomax)) 
+           ! we have multiplied by exp to prevent erosion when rhos>rhomax (usefull till
+           ! rhohard<450)
+       enddo
+       
+       ! computation of qbs at the top of the saltation layer
+       ! two formulations possible
+       ! pay attention that qbs is a mixing ratio and has to be converted
+       ! to specific content
+       
+       if (iflag_saltation_bs .eq. 1) then
+       ! expression from CRYOWRF (Sharma et al. 2022)
+          aa=2.6
+          bb=2.5
+          cc=2.0
+          lambdasalt=0.45
+          do j =1, knon
+               rhod=p1lay(j)/RD/temp_air(j)
+               nunu=max(ustar(j)/ustart(j),1.e-3)
+               fluxsalt=rhod/RG*(ustar(j)**3)*(1.-nunu**(-2)) * &
+                        (aa+bb*nunu**(-2)+cc*nunu**(-1))  
+               csalt=fluxsalt/(2.8*ustart(j))
+               hsalt(j)=0.08436*ustar(j)**1.27
+               qsalt(j)=1./rhod*csalt*lambdasalt*RG/(max(ustar(j)**2,1E-6)) &
+                       * exp(-lambdasalt*RG*hsalt(j)/max(ustar(j)**2,1E-6))
+               qsalt(j)=max(qsalt(j),0.)
+          enddo
+
+
+       else
+       ! default formulation from MAR model (Amory et al. 2021, Gallee et al. 2001)        
+          do j=1, knon
+              esalt=1./(3.25*max(ustar(j),0.001))
+              hsalt(j)=0.08436*ustar(j)**1.27
+              qsalt(j)=(max(ustar(j)**2-ustart(j)**2,0.))/(RG*hsalt(j))*esalt
+              !ep=qsalt*cdragm(j)*sqrt(u1(j)**2+v1(j)**2)
+          enddo
+       endif
+
+        ! calculation of erosion (flux positive towards the surface here) 
+        ! consistent with implicit resolution of turbulent mixing equation
+       do j=1, knon
+              i = knindex(j)
+              rhod=p1lay(j)/RD/temp_air(j)
+              ! Nemoto and Nishimura 2004 show that steady-state saltation is achieved within an interval of about 10s
+              ! we thus prevent snowerosion (snow particle transfer from the saltation layer to the first model level)
+              ! to exceed (in intensity) integrated over 10s to exceed the total mass of snow particle in the saltation layer
+              ! (rho*qsalt*hsalt)
+              maxerosion=hsalt(j)*qsalt(j)*rhod/10.
+              fluxbs(j)=rhod*ws1(j)*cdragm(j)*(AcoefQBS(j)-qsalt(j)) &
+                       / (1.-rhod*ws1(j)*cdragm(j)*BcoefQBS(j)*dtime)
+              !fluxbs(j)= rhod*ws1(j)*cdragm(j)*(qbs1(j)-qsalt(j))
+              fluxbs(j)=max(-maxerosion,fluxbs(j))
+
+              ! for outputs
+
+              zxustartlic(i) = ustart(j)
+              zxrhoslic(i) = rhos(j)
+       enddo
+
+  endif
+
+
+
+!****************************************************************************************
+! Calculate surface snow amount
 !    
 !****************************************************************************************
+    IF (ok_bs) THEN
+      precip_totsnow(:)=precip_snow(:)+precip_bs(:)
+      evap_totsnow(:)=evap(:)-fluxbs(:) ! flux bs is positive towards the surface (snow erosion)
+    ELSE
+      precip_totsnow(:)=precip_snow(:)
+      evap_totsnow(:)=evap(:)
+    ENDIF
+
     CALL fonte_neige(knon, is_lic, knindex, dtime, &
-         tsurf, precip_rain, precip_snow, &
-         snow, qsol, tsurf_new, evap &
+         tsurf, precip_rain, precip_totsnow, &
+         snow, qsol, tsurf_new, evap_totsnow &
 #ifdef ISO    
      & ,fq_fonte_diag,fqfonte_diag,snow_evap_diag,fqcalving_diag   &
@@ -446,35 +586,6 @@
 
 
-!****************************************************************************************
-! Calculate albedo
-!
-!****************************************************************************************
-    CALL albsno(klon,knon,dtime,agesno(:),alb_neig(:), precip_snow(:))  
-
-    WHERE (snow(1 : knon) .LT. 0.0001) agesno(1 : knon) = 0.
-    zfra(1:knon) = MAX(0.0,MIN(1.0,snow(1:knon)/(snow(1:knon)+10.0)))
-    alb1(1:knon) = alb_neig(1:knon)*zfra(1:knon) + &
-         0.6 * (1.0-zfra(1:knon))
-!
-!IM: plusieurs choix/tests sur l'albedo des "glaciers continentaux"
-!       alb1(1 : knon)  = 0.6 !IM cf FH/GK 
-!       alb1(1 : knon)  = 0.82
-!       alb1(1 : knon)  = 0.77 !211003 Ksta0.77
-!       alb1(1 : knon)  = 0.8 !KstaTER0.8 & LMD_ARMIP5
-!IM: KstaTER0.77 & LMD_ARMIP6    
-
-! Attantion: alb1 and alb2 are not the same!
-    alb1(1:knon)  = alb_vis_sno_lic
-    alb2(1:knon)  = alb_nir_sno_lic
-
-
-!****************************************************************************************
-! Rugosity
-!
-!****************************************************************************************
-    z0m=1.e-3
-    z0h = z0m
-    z0m = SQRT(z0m**2+rugoro**2)
-
+    WHERE (snow(1 : knon) .LT. 0.0001) agesno(1 : knon) = 0.                                         
+    zfra(1:knon) = MAX(0.0,MIN(1.0,snow(1:knon)/(snow(1:knon)+10.0)))  
 
 
@@ -494,5 +605,5 @@
           run_off_lic_frac(j) = pctsrf(i,is_lic)
        ENDDO
-       
+
        CALL cpl_send_landice_fields(itime, knon, knindex, run_off_lic, run_off_lic_frac)
     ENDIF
@@ -501,16 +612,4 @@
     runoff(1:knon)=run_off_lic(1:knon)/dtime
 
-  
-!****************************************************************************************
-! Etienne: comment these lines because of duplication just below
-!       snow_o=0.
-!       zfra_o = 0.
-!       DO j = 1, knon
-!           i = knindex(j)
-!           snow_o(i) = snow(j) 
-!           zfra_o(i) = zfra(j)
-!       ENDDO
-!
-!****************************************************************************************
        snow_o=0.
        zfra_o = 0.
@@ -553,6 +652,4 @@
 !albedo SB <<<
 
-  
-  
 
   END SUBROUTINE surf_landice
Index: /LMDZ6/branches/LMDZ_ECRad/libf/phylmdiso/surf_ocean_mod.F90
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/phylmdiso/surf_ocean_mod.F90	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/phylmdiso/surf_ocean_mod.F90	(revision 4727)
@@ -13,5 +13,5 @@
        windsp, rmu0, fder, tsurf_in, &
        itime, dtime, jour, knon, knindex, &
-       p1lay, z1lay, cdragh, cdragm, precip_rain, precip_snow, temp_air, spechum, &
+       p1lay, z1lay, cdragh, cdragm, precip_rain, precip_snow, precip_bs, temp_air, spechum, &
        AcoefH, AcoefQ, BcoefH, BcoefQ, &
        AcoefU, AcoefV, BcoefU, BcoefV, &
@@ -72,5 +72,5 @@
     REAL, DIMENSION(klon), INTENT(IN)        :: cdragh
     REAL, DIMENSION(klon), INTENT(IN)        :: cdragm
-    REAL, DIMENSION(klon), INTENT(IN)        :: precip_rain, precip_snow
+    REAL, DIMENSION(klon), INTENT(IN)        :: precip_rain, precip_snow, precip_bs
     REAL, DIMENSION(klon), INTENT(IN)        :: temp_air, spechum
     REAL, DIMENSION(klon), INTENT(IN)        :: AcoefH, AcoefQ, BcoefH, BcoefQ
@@ -169,4 +169,5 @@
     REAL, DIMENSION(klon) :: radsol
     REAL, DIMENSION(klon) :: cdragq ! Cdrag pour l'evaporation
+    REAL, DIMENSION(klon) :: precip_totsnow
     CHARACTER(len=20),PARAMETER :: modname="surf_ocean"
     real rhoa(knon) ! density of moist air  (kg / m3)
@@ -200,4 +201,14 @@
     radsol(1:knon) = swnet(1:knon) + lwnet(1:knon)
 
+
+    !****************************************************************************************
+    !Total solid precip
+
+    IF (ok_bs) THEN
+       precip_totsnow(:)=precip_snow(:)+precip_bs(:)
+    ELSE
+       precip_totsnow(:)=precip_snow(:)
+    ENDIF
+
     !******************************************************************************
     ! Cdragq computed from cdrag
@@ -227,5 +238,5 @@
             windsp, fder, & 
             itime, dtime, knon, knindex, &
-            p1lay, cdragh, cdragq, cdragm, precip_rain, precip_snow,temp_air,spechum,& 
+            p1lay, cdragh, cdragq, cdragm, precip_rain, precip_totsnow,temp_air,spechum,& 
             AcoefH, AcoefQ, BcoefH, BcoefQ, &
             AcoefU, AcoefV, BcoefU, BcoefV, &
@@ -239,5 +250,5 @@
        CALL ocean_slab_noice( &
             itime, dtime, jour, knon, knindex, &
-            p1lay, cdragh, cdragq, cdragm, precip_rain, precip_snow, temp_air, spechum,&
+            p1lay, cdragh, cdragq, cdragm, precip_rain, precip_totsnow, temp_air, spechum,&
             AcoefH, AcoefQ, BcoefH, BcoefQ, &
             AcoefU, AcoefV, BcoefU, BcoefV, &
@@ -250,5 +261,5 @@
        CALL ocean_forced_noice( &
             itime, dtime, jour, knon, knindex, &
-            p1lay, cdragh, cdragq, cdragm, precip_rain, precip_snow, &
+            p1lay, cdragh, cdragq, cdragm, precip_rain, precip_totsnow, &
             temp_air, spechum, &
             AcoefH, AcoefQ, BcoefH, BcoefQ, &
@@ -370,5 +381,5 @@
        call bulk_flux(tkt, tks, taur, dter, dser, t_int, s_int, ds_ns, dt_ns, &
             u = windsp(:knon), t_ocean_1 = tsurf_new(:knon), s1 = sss(:knon), &
-            rain = precip_rain(:knon) + precip_snow(:knon), &
+            rain = precip_rain(:knon) + precip_totsnow(:knon), &
             hf = - fluxsens(:knon), hlb = - fluxlat(:knon), &
             rnl = - lwnet(:knon), &
Index: /LMDZ6/branches/LMDZ_ECRad/makelmdz
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/makelmdz	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/makelmdz	(revision 4727)
@@ -17,4 +17,9 @@
 couple=false
 veget=false
+inlandsis=false
+rrtm=false
+rad="oldrad"
+dust=false
+strataer=false
 chimie=false
 parallel=none
@@ -27,9 +32,5 @@
 cosp2=false
 cospv2=false
-inlandsis=false
-rrtm=false
-rad=""
-dust=false
-strataer=false
+
 full=""
 
@@ -110,10 +111,10 @@
 [-p PHYS]                  : set of physical parametrizations (in libf/phyPHYS), (default: lmd)
 [-prod / -dev / -debug]    : compilation mode production (default) / developement / debug
-[-c false/MPI1/MPI2]       : coupling with ocean model : MPI1/MPI2/false (default: false)
+[-c false/MPI1/OMCT]       : coupling with ocean model : MPI1/OMCT/false (default: false)
 [-v false/orchideetrunk/orchidee2.1/orchidee2.0/orchidee1.9] : version of the vegetation model to include (default: false)
           false       : no vegetation model
           orchideetrunk : compile using ORCHIDEE trunk from revision 7757 or higher
           orchidee2.1 : compile using ORCHIDEE 2.1 until 4.1 included or until revision 7757 on the trunk
-          orchidee2.0 : compile using ORCHIDEE 2.0 (or more recent version)
+          orchidee2.0 : compile using ORCHIDEE 2.0
           orchidee1.9 : compile using ORCHIDEE up to the version including OpenMP in ORCHIDEE : tag 1.9-1.9.5(version AR5)-1.9.6
           true        : (obsolete; for backward compatibility) use ORCHIDEE tag 1.9-1.9.6
@@ -125,6 +126,6 @@
 [-rrtm true/false]    : compile with/without rrtm package (default: false)
 [-rad oldrad/rrtm/ecrad]    : compile with oldrad/rrtm/ecrad radiatif code (default: oldrad)
-[-dust true/false]    : compile with/without the dust package from Boucher et al. (default: false)
-[-strataer true/false]    : compile with/without the strat aer package from Boucher et al. (default: false)
+[-dust true/false]    : compile with/without the dust package by Boucher and co (default: false)
+[-strataer true/false]    : compile with/without the strat aer package by Boucher and co (default: false)
 [-parallel none/mpi/omp/mpi_omp] : parallelism (default: none) : mpi, openmp or mixted mpi_openmp
 [-g GRI]                   : grid configuration in dyn3d/GRI_xy.h  (default: reg, inclues a zoom)
@@ -135,6 +136,6 @@
 [-mem]                     : reduced memory dynamics (obsolete flag; always on in parallel mode)
 [-filtre NOMFILTRE]        : use filtre from libf/NOMFILTRE (default: filtrez)
-[-full]                    : Full (re)compilation (from scratch)
 [-link LINKS]              : additional links with other libraries
+[-full]                    : full recompiling 
 [-fcm_path path]           : path to the fcm tool (default: tools/fcm/bin)
 [-ext_src path]            : path to an additional set of routines to compile with the model
@@ -171,25 +172,4 @@
 	  veget="$2" ; shift ; shift ;;
 
-      "-chimie")
-	  chimie="$2" ; shift ; shift ;;
-
-      "-parallel")
-	  parallel="$2" ; shift ; shift ;;
-      
-      "-include")
-	  INCLUDE="$INCLUDE -I$2" ; shift ; shift ;;
-
-      "-cpp")
-	  CPP_KEY="$CPP_KEY $2" ; shift ; shift ;;
-
-      "-cosp")
-          cosp="$2" ; shift ; shift ;;
-
-      "-cosp2")
-          cosp2="$2" ; shift ; shift ;;
-
-      "-cosp2")
-          cospv2="$2" ; shift ; shift ;;
-      
       "-inlandsis")
           inlandsis="$2" ; shift ; shift ;;  
@@ -207,4 +187,25 @@
           strataer="$2" ; shift ; shift ;;
       
+      "-chimie")
+	  chimie="$2" ; shift ; shift ;;
+
+      "-parallel")
+	  parallel="$2" ; shift ; shift ;;
+      
+      "-include")
+	  INCLUDE="$INCLUDE -I$2" ; shift ; shift ;;
+
+      "-cpp")
+	  CPP_KEY="$CPP_KEY $2" ; shift ; shift ;;
+
+      "-cosp")
+          cosp="$2" ; shift ; shift ;;
+
+      "-cosp2")
+          cosp2="$2" ; shift ; shift ;;
+
+      "-cospv2")
+          cospv2="$2" ; shift ; shift ;;
+      
       "-mem")
           echo "option -mem is obsolete (now always on in parallel)"
@@ -214,15 +215,15 @@
 	  filtre=$2 ; shift ; shift ;;
 
+      "-link")
+	  LIB="$LIB $2" ; shift ; shift ;;
+
+      "-fcm_path")
+	  fcm_path=$2 ; shift ; shift ;;
+
+      "-ext_src")
+	  EXT_SRC=$2 ; src_dirs="$src_dirs $EXT_SRC" ; shift ; shift ;;
+
       "-full")
       full="full" ; shift ;;
-
-      "-link")
-	  LIB="$LIB $2" ; shift ; shift ;;
-
-      "-fcm_path")
-	  fcm_path=$2 ; shift ; shift ;;
-
-      "-ext_src")
-	  EXT_SRC=$2 ; src_dirs="$src_dirs $EXT_SRC" ; shift ; shift ;;
 
       "-arch")
@@ -364,8 +365,8 @@
    lib_phy='-lphy'"$physique"' -lphy_common'
    CPP_KEY="$CPP_KEY CPP_PHYS"
-   if [[ $phys_root == "lmd" ]]
-      then
-      #For lmd physics, default planet type is Earth
-      CPP_KEY="$CPP_KEY CPP_EARTH"
+   if [[ "${phys_root}" == "lmd" ]]
+   then
+   #For lmd physics, default planet type is Earth
+   CPP_KEY="$CPP_KEY CPP_EARTH"
    fi
 fi
@@ -475,7 +476,37 @@
 fi
 
+if [[ "$inlandsis" == "true" ]]
+then
+   CPP_KEY="$CPP_KEY CPP_INLANDSIS"
+   src_dirs="$src_dirs phy${physique}/inlandsis"
+fi
+
+
+if [[ "$rad" == "rrtm" ]]
+then
+   CPP_KEY="$CPP_KEY CPP_RRTM"
+   src_dirs="$src_dirs phy${physique}/rrtm"
+fi
+if [[ "$rad" == "ecrad" ]]
+then
+   CPP_KEY="$CPP_KEY CPP_ECRAD"
+   src_dirs="$src_dirs phy${physique}/ecrad"
+fi
+
+if [[ "$dust" == "true" ]]
+then
+   CPP_KEY="$CPP_KEY CPP_Dust"
+   src_dirs="$src_dirs phy${physique}/Dust"
+fi
+
+if [[ "$strataer" == "true" ]]
+then
+   CPP_KEY="$CPP_KEY CPP_StratAer"
+   src_dirs="$src_dirs phy${physique}/StratAer"
+fi
+
 #===============================================================================
-INCLUDE="$INCLUDE -I${NETCDF95_INCDIR}"
-LIB="$LIB -L${NETCDF95_LIBDIR} -l${LIBPREFIX}netcdf95"
+INCLUDE="$INCLUDE ${NETCDF95_INCDIR}"
+LIB="$LIB ${NETCDF95_LIBDIR} -l${LIBPREFIX}netcdf95"
 
 if [[ $io == ioipsl ]]
@@ -524,33 +555,4 @@
 
 
-if [[ "$inlandsis" == "true" ]]
-then
-   CPP_KEY="$CPP_KEY CPP_INLANDSIS"
-   src_dirs="$src_dirs phy${physique}/inlandsis"
-fi
-
-
-if [[ "$rad" == "rrtm" ]]
-then
-   CPP_KEY="$CPP_KEY CPP_RRTM"
-   src_dirs="$src_dirs phy${physique}/rrtm"
-fi
-if [[ "$rad" == "ecrad" ]]
-then
-   CPP_KEY="$CPP_KEY CPP_ECRAD"
-   src_dirs="$src_dirs phy${physique}/ecrad"
-fi
-
-if [[ "$dust" == "true" ]]
-then
-   CPP_KEY="$CPP_KEY CPP_Dust"
-   src_dirs="$src_dirs phy${physique}/Dust"
-fi
-
-if [[ "$strataer" == "true" ]]
-then
-   CPP_KEY="$CPP_KEY CPP_StratAer"
-   src_dirs="$src_dirs phy${physique}/StratAer"
-fi
 
 #add new ocean skin modelisation to source dir by default
@@ -804,39 +806,5 @@
 # Execution du make
 #################################################################
-echo $makecommand RANLIB=$ranlib -f $LMDGCM/makefile \
-OPTION_DEP="$opt_dep" OPTION_LINK="$LIB ${PARA_LD}" \
-OPTIM90="${COMPIL_FFLAGS} ${PARA_FFLAGS}" \
-OPTIMTRU90="${COMPIL_FFLAGS} ${PARA_FFLAGS}" \
-OPTIM="${COMPIL_FFLAGS} ${PARA_FFLAGS}" \
-INCLUDE="$INCLUDE" \
-$filtre \
-LIBO=${LIBOGCM}/${nomlib} \
-"PHYS=$physique" \
-LIBPHY=${LIBPHY} \
-LIBPHY_COMMON=${LIBPHY_COMMON} \
-LIBDYN_PHYS=${LIBDYN_PHYS} \
-DIM=$dimc \
-FLAG_PARA=$FLAG_PARA \
-L_PHY="$lib_phy" \
-L_DYN_PHY="$libdyn_phy" \
-L_ADJNT=$adjnt \
-L_COSP="$lcosp" \
-L_COSP2="$lcosp2" \
-L_COSPV2="$lcospv2" \
-L_CHIMIE="$libchimie" \
-LOCAL_DIR="$localdir"  \
-F77="$fcompiler" \
-F90="$fcompiler" \
-OPLINK="$LIB" \
-LINK="$linker" \
-GCM="$LMDGCM" \
-MOD_LOC_DIR=$mod_loc_dir \
-MOD_SUFFIX="mod" \
-AR=$arcommand \
-ARFLAGS="$arflags" \
-DIRMAIN=$dirmain \
-SOURCE=$source_code \
-PROG=$code
-
+set -v
 $makecommand RANLIB=$ranlib -f $LMDGCM/makefile \
 OPTION_DEP="$opt_dep" OPTION_LINK="$LIB ${PARA_LD}" \
@@ -874,4 +842,5 @@
 PROG=$code
 
+set +v
 
 if [[ -r $LIBFGCM/grid/dimensions.h ]]
Index: /LMDZ6/branches/LMDZ_ECRad/tools/compare_real.py
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/tools/compare_real.py	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/tools/compare_real.py	(revision 4727)
@@ -1,5 +1,6 @@
+#!/usr/bin/env python3
+
 """This script should be called by "diffdef.sh". It operates on
-different lines with common variables. It requires version 2.7 or
-higher of Python (it also works with Python 3).
+different lines with common variables.
 
 Author: Lionel GUEZ"""
Index: /LMDZ6/branches/LMDZ_ECRad/tools/diffdef.sh
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/tools/diffdef.sh	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/tools/diffdef.sh	(revision 4727)
@@ -2,6 +2,6 @@
 # Author: Lionel GUEZ
 
-# This script compares files "*.def" other than "*traceur.def" and
-# "out.def" in two directories.
+# This script compares files "*.def" other than "traceur.def",
+# "tracer.def", "isotopes_params.def" and "out.def" in two directories.
 
 # This script uses GNU versions of the utilities cut, sort and uniq,
@@ -9,10 +9,10 @@
 
 # See guide:
-# http://lmdz.lmd.jussieu.fr/utilisateurs/outils/utilisation-de-lmdz#section-5
+# http://lmdz.lmd.jussieu.fr/utilisateurs/utilisation-de-lmdz#section-5
 
 USAGE="usage: `basename $0` directory_1 directory_2"
 
 if (($# != 2))
-    then
+then
     echo "$USAGE" >&2
     exit 1
@@ -20,13 +20,4 @@
 
 ##set -x
-
-type python3 >/dev/null 2>&1
-if (($? == 0))
-then
-    my_python=python3
-else
-    my_python=python
-fi
-
 set -e
 
@@ -40,42 +31,44 @@
 
 for my_directory in $*
-  do
-  cd $my_directory
-  rm -f all.def
-  echo "def files in $my_directory:"
-  ls !(*traceur|out).def
+do
+    cd $my_directory
+    rm -f all.def
+    echo "def files in $my_directory:"
+    ls !(traceur|tracer|out|isotopes_params).def
 
-  # Concatenate and format the def files:
-  cat !(*traceur|out).def | tr '\r' '\n' | tr -d " " \
-      | grep -v -E '(^#|^!|INCLUDEDEF|^$)' \
-      | tr '[:lower:]' '[:upper:]' | sed 's/=[NF]$/=FALSE/' \
-      | sed 's/=[YT]$/=TRUE/' | sort >all.def
+    # Concatenate and format the def files:
+    cat !(traceur|tracer|out|isotopes_params).def | tr -d " \t" \
+	| grep -v -E '(^#|^!|INCLUDEDEF|^$)' \
+	| tr '[:lower:]' '[:upper:]' | sed 's/=[NF]$/=FALSE/' \
+	| sed 's/=[YT]$/=TRUE/' | sort >all.def
 
-  # Check that no variable is repeated:
-  cut --fields=1 --delimiter="=" all.def | uniq --repeated >plouf_$$
-  if [[ -s plouf_$$ ]]
-      then
-      echo
-      echo "Error: a variable is repeated in directory \"$my_directory\"."
-      echo
-      echo "Here is the list of repeated variables in directory \"$my_directory\":"
-      echo
-      cat plouf_$$
-      rm plouf_$$
-      rm all.def
-      exit 1
-  fi
-  rm plouf_$$
-
-  cd - >/dev/null
+    # Check that no variable is repeated:
+    
+    cut --fields=1 --delimiter="=" all.def | uniq --repeated >plouf_$$
+    
+    if [[ -s plouf_$$ ]]
+    then
+	echo
+	echo "Error: a variable is repeated in directory \"$my_directory\"."
+	echo
+	echo "Here is the list of repeated variables in directory " \
+	     "\"$my_directory\":"
+	echo
+	cat plouf_$$
+	rm plouf_$$
+	rm all.def
+	exit 1
+    fi
+    
+    rm plouf_$$
+    cd - >/dev/null
 done
-
 
 sort $1/all.def $2/all.def | uniq --repeated >common_lines
 
 for my_directory in $*
-  do
-  sort $my_directory/all.def common_lines | uniq --unique \
-      >$my_directory/uniq_lines
+do
+    sort $my_directory/all.def common_lines | uniq --unique \
+						   >$my_directory/uniq_lines
 done
 
@@ -86,13 +79,13 @@
 
 for my_directory in $*
-  do
-  cd $my_directory
-  echo "Created file \"$my_directory/uniq_var\"."
-  sort uniq_lines uniq_var | uniq --unique >common_var
-  rm uniq_lines
-  cd - >/dev/null
+do
+    cd $my_directory
+    echo "Created file \"$my_directory/uniq_var\"."
+    sort uniq_lines uniq_var | uniq --unique >common_var
+    rm uniq_lines
+    cd - >/dev/null
 done
 
-$my_python $script_dir/compare_real.py $*
+$script_dir/compare_real.py $*
 sort common_lines --output=common_lines # was modified by the Python script
 echo "Created files \"./common_lines\" and \"./uniq_val\"."
@@ -100,5 +93,5 @@
 # Clean up:
 for my_directory in $*
-  do
+do
     rm $my_directory/common_var $my_directory/all.def
 done
